use serde::Deserialize;

// TODO: either use rbw-agent as the backend, or adjust structs to rbw db.rs & api.rs

#[derive(Debug, Deserialize)]
pub struct Sync {
    pub success: bool,
}


#[derive(Debug, Deserialize)]
pub struct Status {
    pub success: bool,
    pub data: StatusData,
}

#[derive(Debug, Deserialize)]
pub struct StatusData {
    pub object: String,
    pub template: StatusDataTemplate,
}

#[derive(Debug, Deserialize)]
pub struct StatusDataTemplate {
    pub serverUrl: String,
    pub lastSync: String,
    pub userEmail: String,
    pub userId: String,
    pub status: String,
}


#[derive(Debug, Deserialize)]
pub struct ListObjectItems {
    pub success: bool,
    pub data: ListObjectItemsData,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectItemsData {
    pub object: String,
    pub data: Vec<ListObjectItemsDataData>,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectItemsDataData {
    pub object: String,
    pub id: String,
    pub organizationId: Option<String>,
    pub folderId: Option<String>,
    #[serde(rename="type")]
    pub _type: i32,
    pub reprompt: i32,
    pub name: String,
    pub notes: Option<String>,
    pub favorite: bool,
    pub login: Option<ListObjectItemsDataLogin>,
    pub collectionIds: Vec<String>,
    pub revisionDate: String,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectItemsDataLogin {
    pub uris: Option<Vec<ListObjectItemsDataLoginURIs>>,
    pub username: Option<String>,
    pub password: Option<String>,
    pub totp: Option<String>,
    pub passwordRevisionDate: Option<String>,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectItemsDataLoginURIs {
    #[serde(rename="match")]
    pub _match: Option<i32>,
    pub uri: Option<String>,
}


#[derive(Debug, Deserialize)]
pub struct ListObjectCollections {
    pub success: bool,
    pub data: ListObjectCollectionsData,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectCollectionsData {
    pub object: String,
    pub data: Vec<ListObjectCollectionsDataData>,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectCollectionsDataData {
    pub object: String,
    pub id: String,
    pub organizationId: String,
    pub name: String,
    pub externalId: Option<String>,
}


#[derive(Debug, Deserialize)]
pub struct ListObjectFolders {
    pub success: bool,
    pub data: ListObjectFoldersData,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectFoldersData {
    pub object: String,
    pub data: Vec<ListObjectFoldersDataData>,
}

#[derive(Debug, Deserialize)]
pub struct ListObjectFoldersDataData {
    pub object: String,
    pub id: Option<String>,
    pub name: String,
}

#[derive(Debug, Deserialize)]
pub struct ObjectItem {
    pub success: bool,
    pub data: ListObjectItemsDataData,
}

